import java.io.IOException;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.DeliveryMode;
import javax.jms.MessageProducer;
import javax.jms.ObjectMessage;
import javax.jms.Session;
import javax.jms.Topic;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class LockTestServlet extends HttpServlet {

    private static final long   serialVersionUID                  = 5955543181588969046L;

    /**
     * JSM Connection Factory
     */
    private ConnectionFactory   cf;

    /**
     * JSM Topic
     */
    private Topic               topic;

    private final static String CONNECTION_FACTORY_JNDI_NAME      = "java:/TestLockConnectionFactory";
    private final static String DEST_JNDI_NAME = "java:/jms/topic/TestLockDestination";

    private void initLockTestServlet() {

        try {
            final Context initCtx = new InitialContext();
            this.cf = (ConnectionFactory) initCtx.lookup(CONNECTION_FACTORY_JNDI_NAME);
            this.topic = (Topic) initCtx.lookup(DEST_JNDI_NAME);
        } catch (final Exception e) {

            throw new RuntimeException(e);
        }
    };

    @Override
    public void init() throws ServletException {

        initLockTestServlet();

    }

    @Override
    protected void doGet(final HttpServletRequest req, final HttpServletResponse resp)
            throws ServletException, IOException {

        doPost(req, resp);
    }

    @Override
    protected void doPost(final HttpServletRequest req, final HttpServletResponse resp)
            throws ServletException, IOException {

        for (int i = 0; i < 15000; i++) {
            Connection connection = null;
            Session session = null;
            MessageProducer producer = null;
            final SyncMessage syncMessage = new SyncMessage();

            try {

                connection = this.cf.createConnection();
                session = connection.createSession(true, Session.SESSION_TRANSACTED);
                producer = session.createProducer(this.topic);
                producer.setDeliveryMode(DeliveryMode.NON_PERSISTENT);
                final ObjectMessage msg = session.createObjectMessage(syncMessage);
                producer.send(msg);
                session.commit();

            } catch (final Exception ex) {

            } finally {
                try {
                    connection.close();
                    session.close();
                    producer.close();
                } catch (final Exception ex) {

                }
            }
        }
    }
}